from Comment import Comment
from OFS.SimpleItem import SimpleItem
from Products.ZCatalog.CatalogPathAwareness import CatalogPathAware
from DateTime import DateTime
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

addActuForm = PageTemplateFile('www/addActu.zpt', globals())
addActuForm._owner = None

def addActuFunction(dispatcher, id, titre, REQUEST=None, submit=None) :
    "Register a news item"
    actu = ActuItem(id, titre)
    dispatcher._setObject(id, actu)

    if REQUEST is not None :
        try : u = dispatcher.DestinationURL()
        except : u = REQUEST['URL1']
        REQUEST.RESPONSE.redirect(u + '/manage_main')

    return ''

class ActuItem(CatalogPathAware, SimpleItem) :
    """
    Class that implement a news item
    """

    meta_type = 'Actualite'
    security = ClassSecurityInfo()

    def __init__(self, id, titre) :
        self.id = id
        self.title = titre
        self.date = DateTime()
        self.resume = ''
        self.contenu = ''
        self.comments = Comment()
    
    security.declareProtected('Edit a news item', 'setResume')
    def setResume(self, summary) :
        """
        Set the resume
        """
        self.resume = summary
        self.index_object()
        self.hasChanged()

    security.declareProtected('Edit a news item', 'setContenu')
    def setContenu(self, content) :
        """
        Set the content
        """
        self.contenu = content
        self.index_object()
        self.hasChanged()
    
    security.declareProtected('Edit a news item', 'setDate')
    def setDate(self, date) :
        """
        Set the content
        """
        self.date = date
        self.index_object()
        self.hasChanged()

    def hasChanged(self) :
        self._p_changed = 1

    def __str__(self) :
        rs = """
id : %s
title : %s
date : %s
resume : %s
contenu : %s
comments : %s
        """ % (self.id, self.title, self.date, self.resume, self.contenu,
        self.comments)
        return rs

InitializeClass(ActuItem)
